package pwc.taxtech.atms.common.util;

import org.apache.poi.ss.formula.OperationEvaluationContext;
import org.apache.poi.ss.formula.eval.EvaluationException;
import org.apache.poi.ss.formula.eval.OperandResolver;
import org.apache.poi.ss.formula.eval.ValueEval;

public class FormulaUtil {
    public static String resolverString(ValueEval[] args, OperationEvaluationContext ec, int index)
            throws EvaluationException {
        return OperandResolver.coerceValueToString(OperandResolver.getSingleValue(args[index], ec.getRowIndex(),
                ec.getColumnIndex()));
    }

    public static Integer resolverInteger(ValueEval[] args, OperationEvaluationContext ec, int index)
            throws EvaluationException {
        return OperandResolver.coerceValueToInt(OperandResolver.getSingleValue(args[index], ec.getRowIndex(),
                ec.getColumnIndex()));
    }

    public static Boolean resolverBoolean(ValueEval[] args, OperationEvaluationContext ec, int index)
            throws EvaluationException {
        return OperandResolver.coerceValueToBoolean(OperandResolver.getSingleValue(args[index], ec.getRowIndex(),
                ec.getColumnIndex()), false);
    }


    public static Double resolverDouble(ValueEval[] args, OperationEvaluationContext ec, int index)
            throws EvaluationException {
        return OperandResolver.coerceValueToDouble(OperandResolver.getSingleValue(args[index], ec.getRowIndex(),
                ec.getColumnIndex()));
    }
}
