package pwc.taxtech.atms.controller;

import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;
import pwc.taxtech.atms.dpo.PagingDto;
import pwc.taxtech.atms.dto.ApiResultDto;
import pwc.taxtech.atms.dto.PagingResultDto;
import pwc.taxtech.atms.dto.vatdto.TrialBalanceDto;
import pwc.taxtech.atms.dto.vatdto.TrialBalanceParam;
import pwc.taxtech.atms.service.impl.DataImportService;
import pwc.taxtech.atms.service.impl.LgGlBalanceService;

import javax.annotation.Resource;
import java.util.List;

@RestController
@RequestMapping("/api/v1/DataImport/")
public class DataImportController extends BaseController {

    @Resource
    private DataImportService dataImportService;
    @Resource
    private LgGlBalanceService lgGlBalanceService;

    @PostMapping("GetBalanceDataForDisplay")
    public PagingResultDto<TrialBalanceDto> getBalanceDataForDisplay(@RequestBody TrialBalanceParam param) {
        PagingResultDto<TrialBalanceDto> resultDto = new PagingResultDto<>();
        List<TrialBalanceDto> list = dataImportService.getBalanceDataForDisplay(param);
        PagingDto pagingDto = new PagingDto();
//        pagingDto.setPageIndex(1);
//        pagingDto.setPageSize(100);
//        pagingDto.setTotalCount(list);
        resultDto.setPageInfo(pagingDto);
        resultDto.setList(list);
        resultDto.setCalculateData(dataImportService.calculateData(list));
        return resultDto;
    }

    @PostMapping("queryGlBalance")
    public ApiResultDto queryGlBalance(@RequestBody TrialBalanceParam param) {
        ApiResultDto resultDto = new ApiResultDto();
        lgGlBalanceService.queryGlBalance(param.getOrgId(), param.getFromPeriod(), param.getToPeriod());
        return resultDto;
    }
}
