package pwc.taxtech.atms.dto;

import com.alibaba.fastjson.annotation.JSONField;
import com.alibaba.fastjson.annotation.JSONType;
import com.fasterxml.jackson.annotation.JsonProperty;

import java.util.Date;

@JSONType(orders = {"id", "operationContent", "action", "operationObject", "originalState", "updateState",
        "operationUser", "ip", "module", "comment", "createTime", "logType"})
public class OperationLogDto {

    @JSONField(name = "id")
    @JsonProperty("id")
    private String id;

    /**
     * 操作内容
     */
    private String operationContent;

    /**
     * 操作行为，如添加，修改，删除
     */
    private Integer action;

    /**
     * 操作对象，新增和删除时存放新增数据名称，修改时存放被修改的字段名
     */
    private String operationObject;

    /**
     * 用于修改数据时存放字段的原始状态，新增和删除时为空
     */
    private String originalState;

    /**
     * 用于修改数据时存放字段的更新后的状态，新增和删除时为空
     */
    private String updateState;

    /**
     * 操作用户：当前数据的操作人员
     */
    private String operationUser;

    /**
     * 操作人IP
     */
    private String ip;

    /**
     * 操作模块
     */
    private Integer module;

    /**
     * 备注信息（新增和删除时存放整个json数据，修改时为空；另也可存放级联禁用启用等特殊情况下的说明）
     */
    private String comment;

    /**
     * 创建时间
     */
    private Date createTime;

    /**
     * 定义日志存那个日志表
     */
    private Integer logType;

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public String getOperationContent() {
        return operationContent;
    }

    public void setOperationContent(String operationContent) {
        this.operationContent = operationContent;
    }

    public String getOperationObject() {
        return operationObject;
    }

    public void setOperationObject(String operationObject) {
        this.operationObject = operationObject;
    }

    public String getUpdateState() {
        return updateState;
    }

    public void setUpdateState(String updateState) {
        this.updateState = updateState;
    }

    public String getOperationUser() {
        return operationUser;
    }

    public void setOperationUser(String operationUser) {
        this.operationUser = operationUser;
    }

    public String getIp() {
        return ip;
    }

    public void setIp(String ip) {
        this.ip = ip;
    }

    public String getComment() {
        return comment;
    }

    public void setComment(String comment) {
        this.comment = comment;
    }

    public Date getCreateTime() {
        return createTime;
    }

    public void setCreateTime(Date createTime) {
        this.createTime = createTime;
    }

    public String getOriginalState() {
        return originalState;
    }

    public void setOriginalState(String originalState) {
        this.originalState = originalState;
    }

    public Integer getAction() {
        return action;
    }

    public void setAction(Integer action) {
        this.action = action;
    }

    public Integer getModule() {
        return module;
    }

    public void setModule(Integer module) {
        this.module = module;
    }

    public Integer getLogType() {
        return logType;
    }

    public void setLogType(Integer logType) {
        this.logType = logType;
    }

}
