package pwc.taxtech.atms.dao;

import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.session.RowBounds;
import pwc.taxtech.atms.MyMapper;
import pwc.taxtech.atms.dpo.ReportDto;
import pwc.taxtech.atms.dpo.TemplateAndGroupDbDto;
import pwc.taxtech.atms.dpo.TemplateUniqDto;
import pwc.taxtech.atms.entity.Template;
import pwc.taxtech.atms.entity.TemplateExample;

import java.util.List;
import java.util.Map;

@Mapper
public interface TemplateMapper extends MyMapper {
    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table TAX_ADMIN.TEMPLATE
     *
     * @mbg.generated
     */
    long countByExample(TemplateExample example);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table TAX_ADMIN.TEMPLATE
     *
     * @mbg.generated
     */
    int deleteByExample(TemplateExample example);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table TAX_ADMIN.TEMPLATE
     *
     * @mbg.generated
     */
    int deleteByPrimaryKey(Long id);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table TAX_ADMIN.TEMPLATE
     *
     * @mbg.generated
     */
    int insert(Template record);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table TAX_ADMIN.TEMPLATE
     *
     * @mbg.generated
     */
    int insertSelective(Template record);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table TAX_ADMIN.TEMPLATE
     *
     * @mbg.generated
     */
    List<Template> selectByExampleWithRowbounds(TemplateExample example, RowBounds rowBounds);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table TAX_ADMIN.TEMPLATE
     *
     * @mbg.generated
     */
    List<Template> selectByExample(TemplateExample example);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table TAX_ADMIN.TEMPLATE
     *
     * @mbg.generated
     */
    Template selectByPrimaryKey(Long id);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table TAX_ADMIN.TEMPLATE
     *
     * @mbg.generated
     */
    int updateByExampleSelective(@Param("record") Template record, @Param("example") TemplateExample example);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table TAX_ADMIN.TEMPLATE
     *
     * @mbg.generated
     */
    int updateByExample(@Param("record") Template record, @Param("example") TemplateExample example);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table TAX_ADMIN.TEMPLATE
     *
     * @mbg.generated
     */
    int updateByPrimaryKeySelective(Template record);

    /**
     * This method was generated by MyBatis Generator.
     * This method corresponds to the database table TAX_ADMIN.TEMPLATE
     *
     * @mbg.generated
     */
    int updateByPrimaryKey(Template record);

    List<TemplateUniqDto> getTemplateUniqDtosByTemplateAndTemplateGroup(Map<String, Object> map);

    /**
     * 根据templateID获取template 和 templategroup 对象
     *
     * @param id templateID
     * @return
     */
    TemplateAndGroupDbDto getTemplateAndGroupById(@Param("id") String id);

    /**
     * 根据模板名称获取模板和模板分组数量
     *
     * @param map 模板组ID， 模板ID，模板名称
     * @return
     */
    long getCountOfTemplateAndGroupByTemplateName(Map<String, Object> map);

    /**
     * 获取模板的所有报表
     *
     * @param map 月份，项目ID，数据库名称，模板组ID
     * @return
     */
    List<ReportDto> getTemplateLeftJoinReport(Map<String, Object> map);

    List<Long> getIdsForExceptTemplate();
}