﻿infrastructureModule.directive('organizationListView', ['$log', '$compile', '$timeout', '$interval',
    function ($log, $compile, $timeout, $interval) {
        'use strict';
        $log.debug('organizationListView.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/admin/infrastructure/organizationListView/organization-list-view.html' + '?_=' + Math.random(),
            scope: {},
            replace: true,
            controller: 'OrganizationListViewController',
            link: function (scope, element) {

                scope.setGridHeight = function () {
                    var pageWrapSelector = ".organization-list-view";
                    var menuSelector = ".menu-header";
                    var contentHeader = '.content-container .header';
                    var dxGridSelctor = "#orgGridContainer";

                    var contentHeaderHeight = parseInt($(contentHeader).css('height').replace('px', ''));
                    var pageHeight = parseInt($(pageWrapSelector).css('height').replace('px', ''));
                    var menuHeight = parseInt($(menuSelector).css('height').replace('px', ''));
                    var height = pageHeight - menuHeight - contentHeaderHeight - 40 + 'px';

                    $(dxGridSelctor).css('max-height', height);
                };


                $(window).resize(function () {
                    scope.setGridHeight();
                });


                var filterSelector = '.filter-select';

                $(filterSelector).on("click", function (e) {
                    e.stopPropagation();
                });

                scope.showFilter = function () {
                    if ($(filterSelector).is(":hidden")) {
                        $(filterSelector).show();
                    } else {
                        $(filterSelector).hide();
                    }

                    $(document).one("click", function () {
                        $(filterSelector).hide();
                    });
                    event.stopPropagation();
                };


            }//# end of link
        }
    }
]);