﻿infrastructureModule.directive('organizationManage', ['$log',
    function ($log) {
        'use strict';
        $log.debug('organizationManage.ctor()...');

        return {
            restrict: 'E',
            templateUrl: '/app/admin/infrastructure/organizationManage/organization-manage.html' + '?_=' + Math.random(),
            replace: true,
            scope: {
                organizationId: '@'
            },
            controller: 'OrganizationManageController',
            link: function (scope, element, attrs, $element) {

                //https://github.com/nathancahill/Split.js/
                Split(['#org-left-container', '#org-right-container'], {
                    //An array of initial sizes of the elements, specified as percentage values. Example: Setting the initial sizes to 25% and 75%.
                    sizes: [20, 80],

                    //An array of minimum sizes of the elements, specified as pixel values. Example: Setting the minimum sizes to 100px and 300px, respectively.
                    minSize: [200, 750],

                    onDragEnd: function () {
                        //$timeout(function () {
                        //    $rootScope.$broadcast(enums.vatEvent.layoutChanged, {});
                        //}, 700);
                    }
                }) 
            }
        };
    }
]);

infrastructureModule.directive('taxPayerNumberUnique', ['$q','orgService',function ($q, orgService) {
    return {
        require: 'ngModel',
        link: function (scope, elm, attrs, ctrl) {
            if (!ctrl) return;

            ctrl.$asyncValidators.taxPayerNumberUnique = function (modelValue, viewValue) {
                if (ctrl.$isEmpty(modelValue)) {
                    $q.resolve();
                }

                var def = $q.defer();

                var id = scope.isAdd ? "" : scope.selectCompany.id;
                orgService.taxPayerNumberUniqueValidate(id, viewValue)
                    .success(function (data, status, headers, config) {
                        if (data) {
                            def.resolve();
                        } else {
                            def.reject();
                        }
                    })
                    .error(function (data, status, headers, config) {
                        def.reject();
                    });

                return def.promise;
            };
        }
    }
}]);

infrastructureModule.directive('codeUnique', ['$q','orgService',function ($q, orgService) {
    return {
        require: 'ngModel',
        link: function (scope, elm, attrs, ctrl) {
            if (!ctrl) return;

            ctrl.$asyncValidators.codeUnique = function (modelValue, viewValue) {
                if (ctrl.$isEmpty(modelValue)) {
                    $q.resolve();
                }

                var def = $q.defer();

                var id = scope.isAdd ? "" : scope.selectCompany.id;
                orgService.codeUniqueValidate(id, viewValue)
                    .success(function (data, status, headers, config) {
                        if (data) {
                            def.resolve();
                        } else {
                            def.reject();
                        }
                    })
                    .error(function (data, status, headers, config) {
                        def.reject();
                    });

                return def.promise;
            };
        }
    }
}]);