﻿systemConfigurationModule.controller('fixedAssetsRuleEngineeController', ['$scope', '$translate', '$log', 'ruleEngineService', 'KeyValueConfigService', 'orgService', 'templateGroupService', 'ruleEngineOp', 'ruleEngineComparer','$timeout',
    function ($scope, $translate, $log, ruleEngineService, KeyValueConfigService, orgService, templateGroupService, ruleEngineOp, ruleEngineComparer, $timeout) {
        $scope.mappingData = [];
        $scope.mainData = [
            {
                id: 1, code: "1", name: "房屋、建筑物", year: "20年",
                mapData: [
                    { id: 1, name: "1 房屋、建筑物", keyValue: "土地、房屋及构建物" },
                    { id: 2, name: "1 房屋、建筑物", keyValue: "土地、海域及无居民海岛" },
                    { id: 3, name: "1 房屋、建筑物", keyValue: "房屋" },
                    { id: 4, name: "1 房屋、建筑物", keyValue: "构建物" }
                ]
            },
            {
                id: 2, code: "2", name: "飞机、火车、轮船、机器、机械和其它生成设备", year: "10年",
                mapData: [
                   { id: 1, name: "2 飞机、火车、轮船、机器、机械和其它生成设备", keyValue: "通用设备" },
                   { id: 2, name: "2 飞机、火车、轮船、机器、机械和其它生成设备", keyValue: "计算机设备及软件" },
                   { id: 3, name: "2 飞机、火车、轮船、机器、机械和其它生成设备", keyValue: "办公设备" },
                   { id: 4, name: "2 飞机、火车、轮船、机器、机械和其它生成设备", keyValue: "车辆" }
                ]
            },
            {
                id: 3, code: "3", name: "与生存经营活动有关的器具、工具、家具等", year: "5年",
                mapData: [
                   { id: 1, name: "3 与生存经营活动有关的器具、工具、家具等", keyValue: "专用设备" },
                   { id: 2, name: "3 与生存经营活动有关的器具、工具、家具等", keyValue: "探矿、采矿、选矿和造块设备" },
                   { id: 3, name: "3 与生存经营活动有关的器具、工具、家具等", keyValue: "石油天然气开采专用设备" },
                   { id: 4, name: "3 与生存经营活动有关的器具、工具、家具等", keyValue: "石油和化学工业专用设备" }
                ]
            },
            {
                id: 4, code: "4", name: "飞机、火车、轮船以外的运输工具", year: "4年",
                mapData: [
                       { id: 1, name: "4 飞机、火车、轮船以外的运输工具", keyValue: "文物" },
                       { id: 2, name: "4 飞机、火车、轮船以外的运输工具", keyValue: "陈列品" },
                ]
            },
            {
                id: 5, code: "5", name: "电子设备", year: "3年",
                mapData: [
                      { id: 1, name: "5 电子设备", keyValue: "图书、档案" }
                ]
            },
        ];
        var editModalSelector = ".fixed-assets-rule-enginee #edit-modal";
        var mappingModalSelector = ".fixed-assets-rule-enginee #map-modal"
        //清空
        $scope.resetEditingObject = function () {
            $scope.editingObject = { code: "", name: "", year: "" };
        }
        //创建
        $scope.createNewData = function () {
            $scope.isEdit = false;

            $scope.resetEditingObject();

            $(editModalSelector).modal('show');
        };

        //保存当前正在编辑数据行,经过界面初步校验后才会进入本功能
        $scope.saveEditRow = function () {
            if ($scope.editingObject.year)
                $scope.editingObject.year = $scope.editingObject.year + "年";
            $scope.mainData.push($scope.editingObject);
            $(editModalSelector).modal('hide');
        };

        //取消保存当前编辑行
        $scope.cancelEditOS = function () {
            $(editModalSelector).modal('hide');
        };
        //删除
        $scope.delete = function (data) {
            var index = $scope.mainData.indexOf(data);
            if (index !== -1) {
                $scope.mainData.splice(index, 1);
            }
        };
        $scope.editRow = function (data) {
            $scope.isEdit = true;
            $scope.editingObject = angular.copy(data)
            if (data.year) {
                var m = data.year.substring(0, data.year.length - 1);
                $scope.editingObject.year = m;
            }

            $(editModalSelector).modal('show');
        };
        $scope.editMapping = function (data) {
            $scope.mappingData = data.mapData;
            $(mappingModalSelector).modal('show');
            $timeout(function () {
                loadDetailMap();
            }, 100);          
        };
        $scope.deleteMap = function (data) {
            var index = $scope.mappingData.indexOf(data);
            if (index !== -1) {
                $scope.mappingData.splice(index, 1);
            }
        };
        $scope.saveMapRow = function () {
            $(mappingModalSelector).modal('hide');
        };

        //初始化invoice datagrid 树
        var InitInvoiceGrid = function () {

            var allowFilter = false;
            $scope.fixedAssetsGridOptions = {
                bindingOptions: {
                    dataSource: 'mainData',
                },
                hoverStateEnabled: true,
                headerFilter: {
                    visible: true,
                    height: 300,
                },
                selection: {
                    mode: "single"
                },
                paging: {
                    enabled: false,
                },
                allowColumnResizing: true,
                columnAutoWidth: true,
                showRowLines: true,
                showColumnLines: true,
                //rowAlternationEnabled: true,
                showBorders: true,
                noDataText: $translate.instant('NoDataText'),
                selectAllText: $translate.instant('SelectAll'),
                onContentReady: function (e) {
                    $scope.invoiceGridInstance = e.component;
                },
                columns: [
                            { dataField: 'code', caption: '标准固定资产代码', allowHeaderFiltering: allowFilter, alignment: 'left', width: 150 },
                    {
                        dataField: 'name', caption: '标准固定资产名称', allowHeaderFiltering: allowFilter, width: 450
                    },
                    { dataField: 'year', caption: '折旧年限', width: 100, allowHeaderFiltering: allowFilter },
                    {
                        dataField: 'id', caption: $translate.instant('Operation'), allowHeaderFiltering: allowFilter, alignment: 'center',
                        cellTemplate: function (container, options) {
                            try {
                                var data = options.data;

                                $("<span class='span-btn' />")
                                       .text("编辑")
                                       .on('click', function () {
                                           $scope.editRow(data);
                                       })
                                   .appendTo(container);

                                $("<span class='span-btn' />")
                                    .text("删除")
                                    .on('click', function () {
                                        $scope.delete(data);
                                    })
                                .appendTo(container);

                                $("<span class='span-btn' />")
                                    .text("对应关系维护")
                                    .on('click', function () {
                                        $scope.editMapping(data);
                                    })
                                .appendTo(container);



                            }
                            catch (e) {
                                $log.error(e);
                            }
                        }
                    },
                ],
            };
        };

        var loadDetailMap = function () {
            var allowFilter = false;
            $scope.fixedAssetsMapGridOptions = {
                bindingOptions: {
                    dataSource: 'mappingData',
                },
                //dataSource:$scope.mappingData,
                hoverStateEnabled: true,
                headerFilter: {
                    visible: true,
                    height: 300,
                },
                selection: {
                    mode: "single"
                },
                paging: {
                    enabled: false,
                },
                allowColumnResizing: true,
                columnAutoWidth: true,
                showRowLines: true,
                showColumnLines: true,
                //rowAlternationEnabled: true,
                showBorders: true,
                noDataText: $translate.instant('NoDataText'),
                selectAllText: $translate.instant('SelectAll'),
                onContentReady: function (e) {
                    $scope.invoiceGridInstance = e.component;
                },
                columns: [
                    { dataField: 'name', caption: '标准固定资产分类', allowHeaderFiltering: allowFilter, alignment: 'left', width: 300 },
                    {
                        dataField: 'keyValue', caption: '企业固定资产名称关键字', allowHeaderFiltering: allowFilter, width: 300
                    },

                    {
                        dataField: 'id', caption: $translate.instant('Operation'), allowHeaderFiltering: allowFilter, alignment: 'center',
                        cellTemplate: function (container, options) {
                            try {
                                var data = options.data;
                                $("<span class='span-btn' />")
                                    .text("删除")
                                    .on('click', function () {
                                        $scope.deleteMap(data);
                                    })
                                .appendTo(container);

                            }
                            catch (e) {
                                $log.error(e);
                            }
                        }
                    },
                ],
            };
        };

        //-----------custom table---end--------------------------
        (function initalization() {
            InitInvoiceGrid();
            loadDetailMap();
        })();
    }]);