angular.module('mc.resizer', []).directive('resizer', ['$document', function ($document) {

    return function ($scope, $element, $attrs) {

        $element.on('mousedown', function (event) {
            event.preventDefault();

            $document.on('mousemove', mousemove);
            $document.on('mouseup', mouseup);
        });

        function mousemove(event) {

            if ($attrs.resizer == 'vertical') {
                // Handle vertical resizer
                var x = event.pageX;

                if ($attrs.resizerMax && x > $attrs.resizerMax) {
                    x = parseInt($attrs.resizerMax);
                }

                $element.css({
                    left: x + 'px'
                });

                $($attrs.resizerLeft).css({
                    width: x + 'px'
                });
                $($attrs.resizerRight).css({
                    left: (x + parseInt($attrs.resizerWidth)) + 'px'
                });

            } else {
                // Handle horizontal resizer
                var y = window.innerHeight - event.pageY;

                //ʱʹĬֵ,ĬֵΪ resizer ָؼĹͬؼĸ߶ȼȥ resizer ĸ߶
                var bottomMax = $($attrs.resizerTop).parent().height() - parseInt($attrs.resizerHeight);
                var customBottomMAx = parseInt($attrs.bottomMax);
                bottomMax = (isNaN(customBottomMAx) || customBottomMAx > bottomMax) ? bottomMax : customBottomMAx;

                if (y > bottomMax) {
                    y = bottomMax;
                }
                
                var bottomMin = $attrs.bottomMin ? parseInt($attrs.bottomMin) : 0;
                if (y < bottomMin) {
                    y = bottomMin;
                }

                if ($attrs.icon && $attrs.iconDiff) {
                    var diff = parseInt($attrs.iconDiff);
                    $('#' + $attrs.icon).css({
                        bottom: (y - diff) + 'px'
                    });
                }

                $element.css({
                    bottom: y + 'px'
                });

                $($attrs.resizerTop).css({
                    bottom: (y + parseInt($attrs.resizerHeight)) + 'px'
                });

                $($attrs.resizerBottom).css({
                    height: y + 'px'
                });
            }
        }

        function mouseup() {
            $document.unbind('mousemove', mousemove);
            $document.unbind('mouseup', mouseup);
        }
    };
}]);