commonModule.
controller('editTemplategroupModalController', ['$scope', '$log', '$translate', '$location', '$timeout', '$interval', '$filter', 'SweetAlert', '$uibModal', 'apiInterceptor', '$q', 'Upload', 'templateGroupService',
    function($scope, $log, $translate, $location, $timeout, $interval, $filter, SweetAlert, $uibModal, apiInterceptor, $q, Upload, templateGroupService) {
        var thisConstant = {
            sheetSelectDxID: window.PWC.newGuid(),
            sheetDxTreeID: window.PWC.newGuid(),

            // 查找现有报表模板
            findSheetDxDropID: window.PWC.newGuid(),
            findSheetDxTreeID: window.PWC.newGuid(),

            // get sheetName list 
            uploadUrl: apiInterceptor.webApiHostUrl + '/templateGroup/getSheetNameList',
            // resumable:true,
            getSheetNameListError: '获取Sheet下拉列表失败',
            getSheetNameTitle: '解析Excel',
            allSheets: '所有报表',
            pleaseSelectFile: '请选择文件',
            pleaseSelectTemplate: '请选择报表',
            deleteSuccess: '删除成功',

            // 上传报表路径
            importTemplateExcelFile: apiInterceptor.webApiHostUrl + '/templateGroup/importTemplateGroupExcelFile',
            // 是否是第一次画sheet 的dropdown
            isFirstDrawDxDropDown: true,
            underLineSeparator: '_',
            codeReg: /^[a-zA-Z0-9]*$/,
            codeError: 'code必须为英文字母或者数字',
        };


        $scope.resource = {
            nameRequire: '请输入报表名称',
        };

        var thisData = {
            // 所有 sheet Name的数组
            sheetNameList: [],
            // 所有sheet name 的列表[{id:1, name:'sheet名称'}]
            sheetNameObjList: [],
            sheetTreeView: null,
            // dropdown的显示文字
            sheetText: thisConstant.allSheets,
            selectSheetNameList: [],

            // 查找现有报表，选择的报表列表
            selectTemplateCodeList: [],

            findSheetTreeView: null
        };

        var thisDataService = {
            newModel: function() {
                var editModel = {};
                editModel.sheetSelectDxID = thisConstant.sheetSelectDxID;
                editModel.templateGroupID = $scope.objectModel.templateGroupID;
                return editModel;
            },

            // 获取sheet列表
            getSheetList: function() {
                if (!$scope.editModel || !$scope.editModel.file) {
                    return;
                }

                var deferred = $q.defer();
                var tempFileName = PWC.newGuid() + '.dat';
                var token = $('input[name="__RequestVerificationToken"]').val();
                $('#busy-indicator-container').show();

                Upload.upload({
                    url: thisConstant.uploadUrl,
                    data: {
                        allowManual: $('#allowManual').is(':checked'),
                        filename: $scope.editModel.file.name,
                        tempFileName: tempFileName,
                    },
                    file: $scope.editModel.file,
                    // resumeChunkSize: resumable ? $scope.chunkSize : null,
                    headers: {
                        'Access-Control-Allow-Origin': '*',
                        Authorization: apiInterceptor.tokenType + ' ' + apiInterceptor.apiToken(),
                        __RequestVerificationToken: token,
                        withCredentials: true
                    },
                    __RequestVerificationToken: token,
                    withCredentials: true
                }).then(function(resp) {
                    var ret = resp.data;
                    $('#busy-indicator-container').hide();
                    deferred.resolve();
                    if (ret.result) {
                        // 导入成功
                        thisData.sheetNameList = ret.data;
                        thisData.sheetNameObjList = thisDataService.parseSheetNameObjList(ret.data);
                        // thisDataService.refreshSheetNameDropDownList(thisData.sheetNameObjList);
                        thisDataService.drawSheetNameDropDownList();

                    } else {

                        if (ret.resultMsg && ret.resultMsg.length > 0) {
                            SweetAlert.warning($translate.instant(ret.resultMsg));

                        } else {

                            SweetAlert.swal({
                                title: thisConstant.getSheetNameTitle,
                                text: thisConstant.getSheetNameListError,
                                type: "info",
                                showCancelButton: false,
                                closeOnConfirm: false,
                                closeOnCancel: true,
                                html: true
                            });

                        }
                    }

                }, function(resp) {
                    deferred.resolve();

                    if (resp.statusText === 'HttpRequestValidationException') {
                        SweetAlert.warning($translate.instant('HttpRequestValidationException'));
                    } else {
                        SweetAlert.warning('SaveFail');
                    }

                    console.log('Error status: ' + resp.status);
                }, function(evt) {
                    deferred.resolve();
                    var progressPercentage = parseInt(100.0 * evt.loaded / evt.total);
                    $log.debug('progress: ' + progressPercentage + '% ' + evt.config.data.file.name);
                });

            },
            // 验证Template 的code list 必须为英文字母或者数字
            validateTemplateCodeList: function(data) {
                if (data && data.length > 0) {
                    for (var i = 0; i < data.length; i++) {
                        if (!thisDataService.validateTemplateCode(data[i])) {
                            return data[i] + thisConstant.codeError;
                        }
                    }
                }

                return null;
            },

            // 验证Template 的code 必须为英文字母或者数字
            validateTemplateCode: function(value) {
                // body...
                var arr = value.split(thisConstant.underLineSeparator);
                if (arr && arr.length > 0) {
                    // code必须为英文字母或者数字
                    if (!thisConstant.codeReg.test(arr[0])) {
                        return false;
                    }
                }

                return true;
            },
            // 转换sheet obj List
            parseSheetNameObjList: function(data) {
                var ret = [];
                if (data && data.length > 0) {
                    for (var i = 0; i < data.length; i++) {
                        var row = data[i];
                        var item = {
                            name: row,
                        };

                        item.id = row;

                        ret.push(item);
                    }
                }

                return ret;
            },
            // 绘制sheet drop down list
            drawSheetNameDropDownList: function() {
                thisData.dxTreeViewDiv = '<div class="tree-view-list margin-sheet" id="' + thisConstant.sheetDxTreeID + '">';
                $("#" + thisConstant.sheetSelectDxID).dxDropDownBox({
                    value: [],
                    valueExpr: "id",
                    displayExpr: "name",
                    // text: thisConstant.allSheets,
                    showClearButton: false,
                    dataSource: thisData.sheetNameObjList,
                    contentTemplate: function(e) {
                        var value = e.component.option("value"),
                            $treeView = $(thisData.dxTreeViewDiv).dxTreeView({
                                dataSource: e.component.option("dataSource"),
                                dataStructure: "plain",
                                keyExpr: "id",
                                parentIdExpr: "parentID",
                                selectionMode: "multiple",
                                displayExpr: "name",
                                selectByClick: true,
                                expandAllEnabled: true,
                                selectNodesRecursive: true,
                                showCheckBoxesMode: "selectAll",
                                selectAllText: '全部',
                                onSelectionChanged: function(args) {
                                    var value = args.component.getSelectedNodesKeys();
                                    thisData.selectSheetNameList = value;
                                    e.component.option("value", value);
                                }
                            });

                        thisData.sheetTreeView = $treeView.dxTreeView("instance");
                        thisData.sheetText = e.component.option("text");

                        e.component.on("valueChanged", function(args) {

                            // var value = args.value;
                            // syncTreeViewSelection(thisData.sheetTreeView, value);
                        });

                        return $treeView;
                    }
                });
            },

            // 上传报表
            save: function(modalInstance) {
                // this.editTemplateGroupModalForm.$setSubmitted();
                $scope.validateName();
                if ($scope.editModel.nameError) {
                    return;
                }

                if (!$scope.editModel || !$scope.editModel.file) {
                    SweetAlert.warning(thisConstant.pleaseSelectFile);
                    return;
                }

                var deferred = $q.defer();
                var tempFileName = PWC.newGuid() + '.dat';
                var token = $('input[name="__RequestVerificationToken"]').val();

                var json = '';

                var model = $scope.editModel;
                model.sheetNameList = thisData.selectSheetNameList;
                if (thisData.selectSheetNameList && thisData.selectSheetNameList.length > 0) {

                    var validateRet = thisDataService.validateTemplateCodeList(thisData.selectSheetNameList);
                    if (validateRet) {
                        SweetAlert.warning(validateRet);
                        return;
                    }

                } else {
                    SweetAlert.warning(thisConstant.pleaseSelectTemplate);
                    return;
                }

                json = JSON.stringify(model);

                // 转圈圈
                $('#busy-indicator-container').show();

                Upload.upload({
                    url: thisConstant.importTemplateExcelFile,
                    data: {
                        allowManual: $('#allowManual').is(':checked'),
                        jsonModel: json,
                        filename: $scope.editModel.file.name,
                        tempFileName: tempFileName
                    },
                    file: $scope.editModel.file,
                    // resumeChunkSize: resumable ? $scope.chunkSize : null,
                    headers: {
                        'Access-Control-Allow-Origin': '*',
                        Authorization: apiInterceptor.tokenType + ' ' + apiInterceptor.apiToken(),
                        __RequestVerificationToken: token,
                        withCredentials: true
                    },
                    __RequestVerificationToken: token,
                    withCredentials: true
                }).then(function(resp) {
                    var ret = resp.data;
                    $('#busy-indicator-container').hide();
                    deferred.resolve();
                    if (ret.result) {
                        // 导入成功
                        modalInstance.close(model);

                    } else {

                        if (ret.resultMsg && ret.resultMsg.length > 0) {
                            SweetAlert.warning(ret.data + $translate.instant(ret.resultMsg));

                        } else {

                            SweetAlert.swal({
                                title: thisConstant.getSheetNameTitle,
                                text: thisConstant.getSheetNameListError,
                                type: "info",
                                showCancelButton: false,
                                closeOnConfirm: false,
                                closeOnCancel: true,
                                html: true
                            });

                        }
                    }

                }, function(resp) {
                    deferred.resolve();

                    if (resp.statusText === 'HttpRequestValidationException') {
                        SweetAlert.warning($translate.instant('HttpRequestValidationException'));
                    } else {
                        SweetAlert.warning($translate.instant('SaveFail'));
                    }

                    console.log('Error status: ' + resp.status);
                }, function(evt) {
                    deferred.resolve();
                    var progressPercentage = parseInt(100.0 * evt.loaded / evt.total);
                    $log.debug('progress: ' + progressPercentage + '% ' + evt.config.data.file.name);
                });
            },
            saveFindAdd: function(modalInstance) {
                // body...

                var model = {
                    serviceTypeID: $scope.editModel.serviceTypeID,
                    payTaxType: $scope.editModel.payTaxType,
                    industryIDs: $scope.editModel.industryIDs,
                    templateGroupID: $scope.editModel.templateGroupID,
                    templateCodeList: thisData.selectTemplateCodeList
                };

                templateGroupService.addExistTemplate(model).success(function(ret) {
                    if (ret.result) {
                        modalInstance.close(model);
                    } else {
                        if (ret.resultMsg && ret.resultMsg.length > 0) {
                            SweetAlert.warning($translate.instant(ret.resultMsg));

                        } else {
                            SweetAlert.warning($translate.instant('SaveFail'));
                        }
                    }
                });
            },

            // 绘制查找sheet的dropdown 列表
            drawFindSheetDropDownList: function(data) {
                // body...
                thisData.dxTreeViewDiv = '<div id="' + thisConstant.findSheetDxTreeID + '">';
                $("#" + thisConstant.findSheetDxDropID).dxDropDownBox({
                    value: [],
                    valueExpr: "code",
                    displayExpr: "name",
                    // text: thisConstant.allSheets,
                    showClearButton: false,
                    dataSource: thisData.allTemplateList,
                    contentTemplate: function(e) {
                        var value = e.component.option("value"),
                            $treeView = $(thisData.dxTreeViewDiv).dxTreeView({
                                dataSource: e.component.option("dataSource"),
                                dataStructure: "plain",
                                keyExpr: "code",
                                parentIdExpr: "parentID",
                                selectionMode: "multiple",
                                displayExpr: "name",
                                selectByClick: true,
                                expandAllEnabled: true,
                                selectNodesRecursive: true,
                                showCheckBoxesMode: "normal",
                                onItemSelectionChanged: function(args) {
                                    var value = args.component.getSelectedNodesKeys();
                                    thisData.selectTemplateCodeList = value;
                                    e.component.option("value", value);
                                }
                            });

                        thisData.findSheetTreeView = $treeView.dxTreeView("instance");
                        thisData.sheetText = e.component.option("text");

                        e.component.on("valueChanged", function(args) {

                            // var value = args.value;
                            // syncTreeViewSelection(thisData.sheetTreeView, value);
                        });

                        return $treeView;
                    }
                });
            },

            // 删除系统级别的报表
            deleteTemplateGroup: function() {
                
                // 删除模板服务
                var deleteTemplate = function(model) {
                    templateGroupService.deleteTemplateGroup(model).success(function(ret) {
                        if (ret.result) {
                            $scope.operateType = null;
                            $scope.isUpdate = true;
                            SweetAlert.warning('删除成功');
                            
                            $scope.onClosed({ model: null });

                        } else {
                            SweetAlert.warning($translate.instant(ret.resultMsg));
                            $scope.operateType = null;
                            $scope.isUpdate = false;
                        }
                    });
                };

                var text = "确定要删除" + $scope.objectModel.name + "吗?";

                SweetAlert.swal({
                        title: '确定删除吗？',
                        text: text,
                        type: "warning",
                        showCancelButton: true,
                        confirmButtonColor: "#DD6B55",
                        confirmButtonText: $translate.instant('Confirm'),
                        cancelButtonText: $translate.instant('Cancel'),
                        closeOnConfirm: false,
                        closeOnCancel: true
                    },
                    function(isConfirm) {
                        if (isConfirm) {
                            var model = $scope.objectModel;


                            deleteTemplate(model);
                        } else{
                            $scope.operateType = null;
                            $scope.isUpdate = false;
                        }
                    });
            },
            // 验证TemplateGroupName
            validateName: function() {
                if ($scope.editModel.name) {
                    $scope.editModel.nameError = null;
                } else {
                    $scope.editModel.nameError = $scope.resource.nameRequire;
                }
            }
        };

        var thisModalService = {

            newModel: function() {
                var editModel = $scope.objectModel;

                $scope.editModel = editModel;
                $scope.editModel.name = '';
                $scope.editModel.sheetSelectDxID = thisConstant.sheetSelectDxID;
                $scope.editModel.file = null;
                $scope.editModel.nameError = null;

                var modalInstance = $uibModal.open({
                    animation: false,
                    ariaLabelledBy: 'modal-title',
                    ariaDescribedBy: 'modal-body',
                    templateUrl: 'editTemplateGroupModal.html',
                    windowClass: 'edit-templategroup-modal-wrapper',
                    scope: $scope,
                    resolve: {
                        editModel: editModel
                    }
                });

                modalInstance.result.then(function(data) {
                    $scope.editModel = data;
                    $scope.operateType = null;
                    $scope.isUpdate = true;

                    $scope.onClosed({ model: data });
                }, function() {
                    $scope.operateType = null;
                    $scope.isUpdate = false;
                    $log.info('Modal dismissed at: ' + new Date());
                });

                $scope.getSheetList = thisDataService.getSheetList;

                $scope.validateName = thisDataService.validateName;

                // 确定
                $scope.save = function() {
                    thisDataService.save(modalInstance)
                }

                // 取消
                $scope.cancel = function() {
                    modalInstance.dismiss('cancel');
                };
            },

            addGroupFirstModal: function () {
                var editModel = $scope.objectModel;

                $scope.editModel = editModel;
                $scope.editModel.title = '添加模板';
                $scope.editModel.name = '';
                $scope.editModel.groupType = 1;
                $scope.editModel.nameError = null;

                var modalInstance = $uibModal.open({
                    animation: false,
                    ariaLabelledBy: 'modal-title',
                    ariaDescribedBy: 'modal-body',
                    templateUrl: 'editTemplateGroupNameModal.html',
                    windowClass: 'edit-template-groupName',
                    scope: $scope,
                    resolve: {
                        editModel: editModel
                    }
                });

                modalInstance.result.then(function (data) {
                    $scope.editModel = data;
                    $scope.operateType = null;
                    $scope.isUpdate = true;
                    $scope.onClosed({ model: data });
                }, function () {
                    $scope.operateType = null;
                    $scope.isUpdate = false;
                    $log.info('Modal dismissed at: ' + new Date());
                });

                $scope.validateName = thisDataService.validateName;

                // 修改报表名称
                $scope.saveUpdateTemplateGroupName = function () {
                    $scope.validateName();
                    if ($scope.editModel.nameError) {
                        return;
                    }

                    templateGroupService.addTemplateGroupWithoutTemplate($scope.editModel).success(function (ret) {
                        if (ret.result) {
                            // 添加成功
                            modalInstance.close($scope.editModel);

                        } else {
                            if (ret.resultMsg && ret.resultMsg.length > 0) {
                                SweetAlert.warning($translate.instant(ret.resultMsg));

                            } else {
                                SweetAlert.warning($translate.instant('SaveFail'));
                            }
                        }
                    });
                };

                // 取消
                $scope.cancel = function () {
                    modalInstance.dismiss('cancel');
                };
            },

            // 编辑报表名称
            editTemplateNameModal: function() {
                var editModel = {
                    name: $scope.objectModel.name,
                    id: $scope.objectModel.id,
                    nameError: null,
                    title: '编辑模板' //'编辑报表' + $scope.objectModel.name
                };

                $scope.editModel = editModel;

                var modalInstance = $uibModal.open({
                    animation: false,
                    ariaLabelledBy: 'modal-title',
                    ariaDescribedBy: 'modal-body',
                    templateUrl: 'editTemplateGroupNameModal.html',
                    windowClass: 'edit-template-groupName',
                    scope: $scope,
                    resolve: {
                        editModel: editModel
                    }
                });

                modalInstance.result.then(function(data) {
                    $scope.editModel = data;
                    $scope.operateType = null;
                    $scope.isUpdate = true;
                    $scope.onClosed({ model: data });
                }, function() {
                    $scope.operateType = null;
                    $scope.isUpdate = false;
                    $log.info('Modal dismissed at: ' + new Date());
                });

                // 修改TemplateGroupName
                var updateTemplateName = function(model) {

                    $scope.validateName();
                    if ($scope.editModel.nameError) {
                        return;
                    }

                    templateGroupService.updateTemplateGroupName(model).success(function(ret) {
                        if (ret.result) {
                            // 导入成功
                            modalInstance.close(model);

                        } else {
                            if (ret.resultMsg && ret.resultMsg.length > 0) {
                                SweetAlert.warning($translate.instant(ret.resultMsg));

                            } else {
                                SweetAlert.warning($translate.instant('SaveFail'));
                            }
                        }
                    });
                };


                $scope.validateName = thisDataService.validateName;

                // 修改报表名称
                $scope.saveUpdateTemplateGroupName = function() {
                    // thisDataService.saveFindAdd(modalInstance)

                    var model = {
                        id: $scope.editModel.id,
                        name: $scope.editModel.name,
                    };

                    updateTemplateName(model);
                };

                // 取消
                $scope.cancel = function() {
                    modalInstance.dismiss('cancel');
                };
            }
        };

        var mainModule = {
            main: function() {

                $scope.editModel = {};
                mainModule.watchFunction();
            },
            watchFunction: function() {
                $scope.$watch('operateType', function(newValue, oldValue) {
                    if (newValue === constant.TemplateGroupOperation.AddDirectly) {
                        thisModalService.newModel();
                    } else if (newValue === constant.TemplateGroupOperation.AddGroupFirst) {
                        thisModalService.addGroupFirstModal();
                    } else if (newValue === constant.TemplateGroupOperation.Delete) {
                        // 删除

                        if ($scope.objectModel) {
                            if (!$scope.objectModel.isSystemType) {
                                // 系统级别直接删除，不用提示
                                thisDataService.deleteTemplateGroup();
                            }
                        }
                    } else if (newValue === constant.TemplateGroupOperation.Edit) {
                        thisModalService.editTemplateNameModal();
                    }
                });
            }
        };

        (function initialize() {
            mainModule.main();

        })();
    }
]);