﻿commonModule.
controller('invoiceExaminationModalController', ['SweetAlert', '$scope', '$log', '$translate', '$location', '$timeout', '$interval', '$uibModal','$document','InvoiceManageService',
    function (SweetAlert, $scope, $log, $translate, $location, $timeout, $interval, $uibModal, $document, InvoiceManageService) {


        $scope.isShow = false;

        $scope.remarksOptions = {
            bindingOptions: {
                value: 'invoiceEntity.comments'
            },
        };
        //模态框
        $scope.modalService = {
            modalInstance: null,
            open: function () {
                var parentSelector = '.invoice-examination-modal-wrapper';
                var parentElem = parentSelector ? angular.element($document[0].querySelector(parentSelector)) : undefined;

                var modalInstance = $uibModal.open({
                    animation: true,
                    ariaLabelledBy: 'modal-title',
                    ariaDescribedBy: 'modal-body',
                    templateUrl: 'invoiceExaminationTemplate.html',
                    scope: $scope,
                    backdrop: 'static',
                    windowClass: 'invoice-examination-modal-wrapper',
                    appendTo: parentElem,
                });

                $scope.modalService.modalInstance = modalInstance;
            },
            //手动验真
            invoceExamination: function () {
                if ($scope.modalService.modalInstance) {
                    $scope.isShow = false;

                    var invoiceList = [];
                   // $scope.invoiceEntity.comments = $scope.comments;
                    invoiceList.push($scope.invoiceEntity);

                    //手动验真
                    InvoiceManageService.invoiceManualExamination(invoiceList).success(function (res) {
                        if (_.isFunction($scope.refreshTable)) {
                            $scope.refreshTable();
                        }
                        SweetAlert.success("验真成功");
                        $scope.modalService.modalInstance.close();
                    }).error(function () {
                        SweetAlert.error('', $translate.instant('CommonFail'));
                    });
                }
            },
            //退票
            invoiceRefund: function () {
                if ($scope.modalService.modalInstance) {
                    $scope.isShow = false;

                    var selectedInvoiceIDList = [];
                   // $scope.invoiceEntity.comments = $scope.comments;
                    selectedInvoiceIDList.push($scope.invoiceEntity.id);

                    var status = constant.inputInvoice.statusType.InvoiceHasRefund.id;

                    InvoiceManageService.updateInvoiceStatus(status, selectedInvoiceIDList).success(function (data) {
                        if (data) {
                            if (_.isFunction($scope.refreshTable)) {
                                $scope.refreshTable();
                                SweetAlert.success("退票成功");
                                $scope.modalService.modalInstance.close();
                            }
                        }
                    }).error(function () {
                        SweetAlert.error('', $translate.instant('CommonFail'));
                    });
                }
            },
        
            cancel: function () {
                if ($scope.modalService.modalInstance) {
                    $scope.isShow = false;
                    $scope.modalService.modalInstance.dismiss('cancel');
                }
            }
        };

        (function initialize() {
            $log.debug('invoiceExaminationModalController.ctor()...');

         
            $scope.$watch('isShow', function (newValue, oldValue) {
                if (newValue) {
                    $scope.modalService.open();
                }
            });
        })();
    }
]);
