﻿commonModule.controller('workflowNodeController', ['$scope', '$log', '$translate', '$timeout', 'apiInterceptor', 'Upload', 'dataImportService', 'SweetAlert', '$q', 'uiGridConstants', 'projectService', 'uiGridGroupingConstants', 'vatImportService', 'i18nService', 'browserService', '$interval', 'region', 'vatSessionService', 'vatCommonService', 'enums','vatWorkflowService',
    function ($scope, $log, $translate, $timeout, apiInterceptor, Upload, dataImportService, SweetAlert, $q, uiGridConstants, projectService, uiGridGroupingConstants, vatImportService, i18nService, browserService, $interval, region, vatSessionService, vatCommonService, enums, vatWorkflowService) {
        'use strict';



        var defaultTaskes = [
            {
                "key": "DataImport",
                "taskes": [{
                    "hasPermission":true,
                    "taskName": "数据预览",
                    "taskUrl": "#/vat/previewData",
                    "taskIsActive": true,
                    "taskIsDone": false,
                    "taskAllowUserToUpdate": true,
                    "orgID": ""


                }]
            }
            , {
                "key": "DataProcess",
                "taskes": [{
                    "hasPermission": true,
                    "taskName": "查看未开票销售",
                    "taskUrl": "#/vat/reductionData/unbilledInvoice",
                    "taskIsActive": true,
                    "taskIsDone": false,
                    "taskAllowUserToUpdate": true,
                    "orgID": ""


                }]
            }

            , {
                "key": "ViewReport",
                "taskes": [
                    {
                    "hasPermission": true,
                    "taskName": "查看财务报表",
                    "taskUrl": "#/vat/generateReport",
                    "taskIsActive": true,
                    "taskIsDone": false,
                    "taskAllowUserToUpdate": true,
                    "orgID": ""


                },
                {
                    "hasPermission": true,
                    "taskName": "查看纳税申报表",
                    "taskUrl": "#/vat/generateReport",
                    "taskIsActive": true,
                    "taskIsDone": false,
                    "taskAllowUserToUpdate": true,
                    "orgID": ""
                }]
            }

             , {
                 "key": "ApproveReport",
                 "taskes": [{
                     "hasPermission": true,
                     "taskName": "查看财务报表",
                     "taskUrl": "#/vat/generateReport",
                     "taskIsActive": true,
                     "taskIsDone": false,
                     "taskAllowUserToUpdate": true,
                     "orgID": ""


                 }
                 , {
                     "hasPermission": true,
                     "taskName": "查看纳税申报表",
                     "taskUrl": "#/vat/generateReport",
                     "taskIsActive": true,
                     "taskIsDone": false,
                     "taskAllowUserToUpdate": true,
                     "orgID": ""


                 }]
             }
              , {
                  "key": "DeclarationComplete",
                  "hasPermission": true,
                  "taskes": [{
                      "taskName": "查看财务报表",
                      "taskUrl": "#/vat/generateReport",
                      "taskIsActive": true,
                      "taskIsDone": false,
                      "taskAllowUserToUpdate": true,
                      "orgID": ""


                  }
                  , {
                      "hasPermission": true,
                      "taskName": "查看纳税申报表",
                      "taskUrl": "#/vat/generateReport",
                      "taskIsActive": true,
                      "taskIsDone": false,
                      "taskAllowUserToUpdate": true,
                      "orgID": ""
                  }]
              }];
        

        $scope.$watch('isShow', function (newValue, oldValue) {
            if (newValue) {
                $('#showParentCodePop').modal('show');
            } else {
                $('#showParentCodePop').modal('hide');
            }
        });

      
        $scope.$watch('uStep', function (newValue, oldValue) {
    
            if (newValue !== undefined) {
                $scope.currentStep = newValue;
            }
        });

        $scope.$watch('uOrg', function (newValue, oldValue) {

            if (newValue !== undefined) {
                $scope.organization = newValue;
            }
        });
        


        var PREV_NODE_STATUS=true;
        $scope.$watch('uList', function (newV, oldV) {
            if (newV !== undefined) {

                var currentOrg = $scope.organization;
                var currentStep=$scope.currentStep

                // Check if all Mandatory taskes are all completed in the Previous Node
                var preViousNodeHasAllMandatoryTaskesCompleted = true;

                if (currentStep > 1) {
                    var previousWorkflow = newV.filter(function (wf) {
                        return wf.orderIndex === (currentStep - 1);
                    });
                    previousWorkflow = previousWorkflow[0];

                    if (previousWorkflow !== undefined && previousWorkflow !== null) {
                        if (previousWorkflow.isDone !== null && previousWorkflow.isDone === true) {
                            preViousNodeHasAllMandatoryTaskesCompleted = true;

                        }
                        else
                        {
                            var isAllCompleted = true;
                            previousWorkflow.workflowTaskList.forEach(function (task) {
                                if (task.isActive && task.isMandatory) {
                                    if (task !== null && task.isDone !== true)
                                        isAllCompleted = false;
                                }
                            });
                            preViousNodeHasAllMandatoryTaskesCompleted = isAllCompleted;
                            PREV_NODE_STATUS = isAllCompleted;
                        }
                    }
                    else
                        preViousNodeHasAllMandatoryTaskesCompleted = PREV_NODE_STATUS;

                }


                //Get the current Step (there are step 1,2,3,4,5)
                var currentWorkflow = newV.filter(function (wf) {
                    return wf.orderIndex === currentStep;
                });

                // Current Node
                var workFlowNodes = [];
                var workflowNode;
                currentWorkflow.forEach(function (thisNode) {
                    workflowNode = new Object();
                    workflowNode.hasPermission = thisNode.hasPermission;
                    workflowNode.nodeName = thisNode.dictionaryValue;
                    workflowNode.nodeIsActive = thisNode.isActive /*||( previousWorkflow!== undefined && !previousWorkflow.isActive) */;
                    workflowNode.nodeIsDone = thisNode.isDone;
                    workflowNode.nodeIsClickable = preViousNodeHasAllMandatoryTaskesCompleted;
                    workflowNode.nodeDoneBy = thisNode.doneBy;
                    workflowNode.nodeDoneOn = (thisNode.doneOn !== null) ? thisNode.doneOn : "";

                    //disable if no taskes:
                    if (thisNode.workflowTaskList.length === 0 || (currentStep > 1 && PREV_NODE_STATUS === false))
                        workflowNode.nodeIsClickable = false;
                
                    // Current Taskes
                    var task;
                    var taskes = [];


                    var defaultTaskesForThisNode = _.find(defaultTaskes, function (defaultTask) { return defaultTask.key === thisNode.dictionaryKey });
                    //*****************************************************************
                    //***************  Add default task for everyone: Add to the Top               
                    if (defaultTaskesForThisNode !== undefined && (defaultTaskesForThisNode.key === "ViewReport" || defaultTaskesForThisNode.key === "ApproveReport" || defaultTaskesForThisNode.key === "DeclarationComplete")) {
                        defaultTaskesForThisNode.taskes.forEach(function (dTask) {
                            task = new Object();
                            task.hasPermission = dTask.hasPermission;
                            task.taskName = dTask.taskName;
                            task.taskUrl = dTask.taskUrl;
                            task.taskIsActive = dTask.taskIsActive;
                            task.taskIsDone = dTask.taskIsDone;
                            task.taskAllowUserToUpdate = dTask.taskAllowUserToUpdate;
                            task.orgID = currentOrg.organizationID;

                            taskes.push(task);
                        });
                    }
                    //***************  Add default task for everyone: Add to the Top
                    //*****************************************************************
                    var noDuplication=true;

                    thisNode.workflowTaskList.forEach(function (item) {
                        task = new Object();
                        task.hasPermission = item.hasPermission;
                        task.taskName = item.dictionaryValue;
                        task.taskUrl = item.vatLink;
                        task.taskIsActive = item.isActive;
                        task.taskIsDone = item.isDone;
                        task.taskAllowUserToUpdate = (item.dictionaryKey === "WFReportApproval") ? false : true; // a label,not button. in step 4 (审核报表)
                        task.reportApprovalStatus = item.reportApprovalStatus;
                        task.reportApprovedNumber = item.reportApprovedNumber;
                        task.orgID = currentOrg.organizationID;
                        task.isMandatory = item.isMandatory;

                        // remove 审核报表 duplications
                        if (item.dictionaryKey !== "WFReportApproval" || (item.dictionaryKey === "WFReportApproval" && noDuplication)) {
                            taskes.push(task);
                            noDuplication = false;
                        }

                    });

                    //*****************************************************************
                    //***************  Add default task for everyone: Add to the Bottom
                  
                    if (defaultTaskesForThisNode !== undefined && (defaultTaskesForThisNode.key === "DataImport" || defaultTaskesForThisNode.key === "DataProcess")) {
                        defaultTaskesForThisNode.taskes.forEach(function (dTask) {
                            task = new Object();
                            task.hasPermission = dTask.hasPermission;
                            task.taskName = dTask.taskName;
                            task.taskUrl = dTask.taskUrl;
                            task.taskIsActive = dTask.taskIsActive;
                            task.taskIsDone = dTask.taskIsDone;


                            task.taskAllowUserToUpdate = dTask.taskAllowUserToUpdate;
                            task.orgID = currentOrg.organizationID;

                            taskes.push(task);
                        });
                    }
                    //***************  Add default task for everyone: Add to the Bottom
                    //*****************************************************************
                    

                    workflowNode.taskes = taskes;
                    workFlowNodes.push(workflowNode);
                });

                $scope.workflowNode = workFlowNodes[0];

            }
        });



        $scope.jumpToPage = function (task) {
            var orgID= task.orgID;
            var url = task.taskUrl;

            if (url !== undefined) {
                var allProjects = vatSessionService.projects;
                var project = _.find(allProjects, function (project) { return (project.organizationID === orgID && project.year === vatSessionService.year && project.serviceTypeID === "2" && vatSessionService.month >= project.startPeriod && vatSessionService.month <= project.endPeriod) });

                if (project.haveCreateProject) {
                    if (_.isUndefined(project.projectStatusList[vatSessionService.month])) { //如果当前期间还没有导入任何数据的话，就添加一条未开始状态的记录
                        projectService.setProjectStatus(project.id, vatSessionService.month, constant.ProjectStatusEnum.UnStarted)
                          .success(function (or) {
                              if (or.result) {
                                  //添加完成后，在vatSessionService.project中添加新加入的数据
                                  project.projectStatusList[vatSessionService.month] = constant.ProjectStatusEnum.UnStarted;
                              }
                          });
                    }

                    vatSessionService.project = project;
                    //vatSessionService.reset();

                    if (url === "#_voucherModal") {
                        $scope.onClickVoucher({ isVoucherModalShow: true });
                    }
                    else if (url === "#_completedTaxFiling") {
                        $scope.declarationComplete(enums.vatLogOperationTypeEnum.ApproveReport);
                    }

                    else {
                        setTimeout(function () {
                            window.location.href = url;
                        }, 200);
                        
                    }
                }
                else {
                    projectService.addProject(project).success(function (rsp) {
                        if (rsp && rsp.result) {
                            project.haveCreateProject = true;
                            project.dbName = rsp.resultMsg;
                            vatSessionService.project = project;
                           

                            setTimeout(function () {
                                window.location.href = url;
                            }, 200);
                        }
                    });
                }
            }
        };


        //enums.vatLogOperationTypeEnum.SubmitReport
        //申报完成
        $scope.declarationComplete = function (operationTypeId) {
            if (
                vatSessionService.project.projectStatusList[vatSessionService.month] >= constant.ProjectStatusEnum.Generated &&
                vatSessionService.project.projectStatusList[vatSessionService.month] !== constant.ProjectStatusEnum.ReportRejected) {
                swal({
                    title: "warning!",
                    text: $translate.instant('IsConfirmToCompleteDeclaration'),
                    type: "warning",
                    showCancelButton: true,
                    confirmButtonColor: "#DD6B55",
                    confirmButtonText: $translate.instant('Yes'),
                    cancelButtonText: $translate.instant('No'),
                    closeOnConfirm: true,
                    closeOnCancel: true
                },
                    function (isConfirm) {
                        if (isConfirm) {
                          //  setApproveValue(operationTypeId);

                            projectService.setProjectStatus(vatSessionService.project.id, vatSessionService.month, constant.ProjectStatusEnum.Completed)
                                .success(function (r1) { //设置项目状态
                                    if (!r1.result) { return false; }
                                  //  $rootScope.$broadcast('statusChanged', { status: constant.ProjectStatusEnum.Completed });
                                    vatSessionService.project.projectStatusList[vatSessionService.month] = constant.ProjectStatusEnum.Completed;
                                    vatWorkflowService.setProcessLog(constant.ProjectStatusEnum.Completed, vatSessionService.project.id, vatSessionService.month, constant.DictionaryDictKey.WFDeclarationComplete, enums.FinishStatusEnum.Finished)
                                        .success(function (r2) { //更新WorkflowTaskLog记录
                                            //if (!r2.result) { return false; }
                                            //vatWorkflowService.addApproveReportLog($scope.approveReportLogDto)
                                            //    .success(function (r3) { //添加WorkflowApproveReportLog记录
                                            //        if (!r3.result) { return false; }
                                            //        vatWorkflowService.getWorkflowDetailByDb(vatSessionService.project.dbName, vatSessionService.month)
                                            //            .success(function (r4) { //获取Workflow详细内容                      
                                            //                if (r4.result) {
                                            //                    vatSessionService.project.workflow = r4.data;
                                            //                    $log.debug("$scope.declarationComplete ： workflowData.result");
                                            //                    $log.debug(vatSessionService.project.workflow);
                                            //                    //setCompleteBtShow();
                                            //                }
                                            //            })
                                            //    })
                                        })
                                });
                        } else {
                            swal.close();
                        }
                    });
            } else {

                SweetAlert.warning($translate.instant('CompleteDeclarationStatusCheck'));
            }
        };

        

        //开始
        (function initialize() {

        })();
    }
]);