﻿webservices.factory('InvoiceManageService', ['$http', 'apiConfig', 'httpCacheService',
function ($http, apiConfig, httpCacheService) {
    'use strict';
     
    return {
        getInvoiceFilterBasicData: function () {
            return $http.get('/invoiceManage/getInvoiceFilterBasicData', apiConfig.create());
        },

        //除去已经失效的invoice，用来做重复验证
        getAllValidInvoiceList: function () {
            return $http.get('/invoiceManage/getAllValidInvoiceList', apiConfig.create());
        },

        //查询invoice according on condition
        getInputInvoiceList: function (queryParm) {
            return $http.post('/invoiceManage/getInputInvoiceList?isUncollect=false', queryParm, apiConfig.create());
        },
        addRefundRemark: function (param) {
            return $http.post('/invoiceManage/addRefundRemark', param, apiConfig.create());
        },
        getInputInvoiceItemList: function (invoiceID) {
            return $http.get('/invoiceManage/getInputInvoiceItemList?inputInvoiceId=' + invoiceID, apiConfig.create());
        },
        getInputInvoiceRefundList: function (queryParm) {
            return $http.post('/invoiceManage/getInputInvoiceList?isUncollect=true', queryParm, apiConfig.create());
        },

        getVerifyFilterBasicData: function () {
            return $http.get('/invoiceManage/getVerifyFilterBasicData', apiConfig.create());
        },
        getInvoiceRelevanceDisplayList: function (queryParam) {
            return $http.post('/invoiceManage/invoiceRelevanceDisplay', queryParam, apiConfig.create());
        },
        //手动认证
        invoiceManualVerify: function (verifyList) {
            return $http.post('/invoiceManage/invoiceManualVerify', verifyList, apiConfig.create());
        },
        //自动认证
        invoiceAutoVerify: function () {
            return $http.post('/invoiceManage/invoiceAutoVerify', apiConfig.create());
        },
        //手动识别
        invoiceManualRecognize: function (invoiceIDList) {
            return $http.post('/invoiceManage/invoiceManualRecognize', invoiceIDList, apiConfig.create());
        },
        //自动识别
        invoiceAutoRecognize: function () {
            return $http.post('/invoiceManage/invoiceAutoRecognize', apiConfig.create());
        },

        //发票验真(系统验真，批量)
        invoiceExamination: function () {
            return $http.post('/invoiceManage/invoiceExamination', apiConfig.create());
        },
        //发票手动验真
        invoiceManualExamination: function (invoiceList) {
            return $http.post('/invoiceManage/invoiceManualExamination', invoiceList, apiConfig.create());
        },

        //退票和失效,变更发票状态
        updateInvoiceStatus: function (invoiceStatusType, invoiceIDList) {
            return $http.post('/invoiceManage/invoiceStatusOperate?invoiceStatusType=' + invoiceStatusType, invoiceIDList, apiConfig.create());
        },
        //扫描枪上传数据
        invoiceUploadFromScan: function (invoiceList) {
            return $http.post('/invoiceManage/invoiceUploadFromScan', invoiceList, apiConfig.create());
        },
    };
}]);