﻿// web service proxy for org
webservices.factory('areaRegionService', ['$http', 'apiConfig', 'httpCacheService',
function ($http, apiConfig, httpCacheService) {
    'use strict';

    return {
        add: function (model) {
            return $http.post('/areaRegion/add', model, apiConfig.create());
        },
        getProvinces: function () {
            //return $http.get('/areaRegion/getProvinces', apiConfig.create());
            return httpCacheService.get('/areaRegion/getProvinces');
        },
        getCities: function (parentID) {
            //return $http.get('/areaRegion/getCities?parentID=' + parentID, apiConfig.create());
            return httpCacheService.get('/areaRegion/getCities?parentID=' + parentID);
        },

        update: function (model) {
            return $http.post('/areaRegion/update', model, apiConfig.create());
        },
        getRegionOrganizationInfo: function () {
            return $http.get('/areaRegion/getRegionOrganizationInfo', apiConfig.create());
        }
    };
}]);