﻿// web service proxy for standard account
webservices.factory('templateFormulaService', ['$http', 'apiConfig', function ($http, apiConfig) {
    'use strict';
    return {
        getByStandardCode: function (standardCode) {
            return $http.get('/templateFormula/getByStandardCode?standardCode=' + standardCode, apiConfig.create());
        },
        getByTemplateGroupID: function (templateGroupID) {
            return $http.get('/templateFormula/getByTemplateGroupID?templateGroupID=' + templateGroupID, apiConfig.create());
        },
        saveTemplateFormulaList: function (templateFormulaList) {
            return $http.post('/templateFormula/saveTemplateFormulaList', templateFormulaList, apiConfig.create());
        },
        getConfigurationAndFormulaByTemplateID: function (templateID) {
            return $http.get('/templateFormula/getConfigurationAndFormulaByTemplateID?templateID=' + templateID, apiConfig.create());
        },
        validate: function (formula) {
            return $http.post('/templateFormula/validate', angular.toJson(formula), apiConfig.create({ ignoreLoadingBar: true }));
        },
        saveOrUpdateCellTemplateConfig: function (templateConfig) {
            return $http.post('/celltemplate/config', templateConfig, apiConfig.create());
        },
        getCellTemplateConfig: function (cellTemplateID) {
            return $http.get('/celltemplate/config/' + cellTemplateID, apiConfig.create());
        },
        getCellTemplateConfigList: function (templateID) {
            return $http.get('/celltemplate/configList/' + templateID, apiConfig.create());
        }


    };
}]);