﻿/// <reference path="../../../Scripts/underscore.js" />
/// <reference path="../../common/utils/enums.js" />
/// <reference path="../nav-bar-util.js" />

// AppNavBarController controller for the navigation bar of the application. This controller is responsible for 
// manage the different types of the tabs and corresponding menus.
frameworkModule.controller('AdminAppNavController', ['$scope', '$rootScope', '$log', 'loginContext', 'enums', '$state',
function ($scope, $rootScope, $log, loginContext, enums, $state) {
    'use strict';
    $log.debug('AdminAppNavController.ctor()...');

    $scope.companyName = loginContext.projectCustomerName;

    $scope.toggleMenu = function () {
        $rootScope.$broadcast(enums.adminEvent.layoutChanged);
    };

    var gotoAdminHomePage = function () {
       $state.go('adminHomePage');
    };

    (function initialize() {
        gotoAdminHomePage();
        $scope.gotoAdminHomePage = gotoAdminHomePage;
     })();

}
]);