﻿
vatModule.controller('VatImportLayoutController', ['$scope', '$log', '$translate', '$location', 'loginContext', 'enums', 'vatSessionService', 'vatCommonService',
function ($scope, $log, $translate, $location, loginContext, enums, vatSessionService, vatCommonService) {
    'use strict';
    $log.debug('VatImportLayoutController.ctor()...');

    if ($location.$$url.startWith('/cit/')) {

        return false;
    }

    //获取未对应企业科目数量
    $scope.$on('notMappedCount', function (e, d) {
        $scope.notMappedCount = d;
    });

    $log.debug("$location && $location.absUrl(): " + $location && $location.absUrl());
    //using .replace(';', '<br/>') to text-wrap at exact position as designed in menu 
    if ($location && $location.absUrl().indexOf('previewData') > -1) {
        $scope.nodeDicKey = constant.DictionaryDictKey.DataImport;
        $scope.linkShort = enums.linkShort.PreviewData;
        $scope.menus = [
            {
                name: 'balanceSheet', permission: constant.vatPermission.dataPreview.balanceSheet.queryCode,
                text: $translate.instant('balanceSheet'), icon: 'fa fa-bank', show: true
            },
//                {
//                    name: 'accountVoucher', permission: constant.vatPermission.dataPreview.accountVoucher.queryCode,
//                    text: $translate.instant('accountVoucher'), icon: 'fa fa-columns', show: true
//                },
            {
                name: 'inputInvoice', permission: constant.vatPermission.dataPreview.inputInvoice.queryCode,
                text: $translate.instant('inputInvoice'), icon: 'fa fa-file-text-o', show: true
            },
            {
                name: 'outputInvoice', permission: constant.vatPermission.dataPreview.outputInvoice.queryCode,
                text: $translate.instant('outputInvoice'), icon: 'fa fa-file-text-o', show: true
            },
//                ,
//                {
//                    name: 'customInvoice', permission: constant.vatPermission.dataPreview.customInvoice.queryCode,
//                    text: $translate.instant('customInvoice'), icon: 'fa fa-bookmark', show: true
//                }
        ];
    }
    else if ($location && $location.absUrl().indexOf('reductionData') > -1) {
        $scope.nodeDicKey = constant.DictionaryDictKey.DataProcess;
        $scope.linkShort = enums.linkShort.ReductionData;
        $scope.menus = [
                {
                    name: 'caculateData', permission: constant.vatPermission.dataManage.caculateDataCode,
                    text: $translate.instant('caculateData'), icon: 'fa fa-random', show: true
                },
            /*{
                name: 'accountMapping', permission: constant.vatPermission.dataManage.accountMappingCode,
                text: $translate.instant('accountMapping'), icon: 'fa fa-map', show: true
            },
            {
                name: 'goodsMapping', permission: constant.vatPermission.dataManage.goodsMappingCode,
                text: $translate.instant('goodsMapping'), icon: 'fa fa-map-signs', show: true
            },
            {
                name: 'unbilledInvoice', permission: constant.vatPermission.dataManage.unbilledInvoiceCode,
                text: $translate.instant('unbilledInvoice'), icon: 'fa fa-shield', show: true
            },*/ ];
    }
    else {
        $scope.nodeDicKey = constant.DictionaryDictKey.DataImport;
        $scope.linkShort = enums.linkShort.ImportData;
        $scope.menus = [
            {
                name: 'balanceSheet', permission: constant.vatPermission.dataImport.balanceSheet.queryCode,
                text: $translate.instant('balanceSheet'), icon: 'fa fa-bank', show: true
            },
//            {
//                name: 'journalEntry', permission: constant.vatPermission.dataImport.journalEntry.queryCode,
//                text: $translate.instant('journalEntry'), icon: 'fa fa-align-left', show: true
//            },
//            {
//                name: 'erpData', permission: constant.vatPermission.dataImport.erpImport.queryCode,
//                text: $translate.instant('erpData'), icon: 'fa fa-list-ul', show: true
//            },

            {
                name: 'inputInvoice', permission: constant.vatPermission.dataImport.inputInvoice.queryCode,
                text: $translate.instant('inputInvoice'), icon: 'fa fa-file-text-o', show: true
            },
            {
                name: 'outputInvoice', permission: constant.vatPermission.dataImport.outputInvoice.queryCode,
                text: $translate.instant('outputInvoice'), icon: 'fa fa-file-text-o', show: true
            },
//            ,
//            {
//                name: 'customInvoice', permission: constant.vatPermission.dataImport.customInvoice.queryCode,
//                text: $translate.instant('customInvoice'), icon: 'fa fa-bookmark', show: true
//            },
//            {
//                name: 'voucherMapping', permission: constant.vatPermission.dataImport.voucherMapping.queryCode,
//                text: $translate.instant('voucherMapping'), icon: 'fa fa-columns', show: true
//            },
//            {
//                name: 'invoiceMapping', permission: constant.vatPermission.dataImport.invoiceMapping.queryCode,
//                text: $translate.instant('invoiceMapping'), icon: 'fa fa-columns', show: true
//            },
//            {
//                name: 'auditAdjust', permission: constant.vatPermission.dataImport.auditAdjust.queryCode,
//                text: $translate.instant('auditAdjust'), icon: 'fa fa-adjust', show: true
//            }
        ];
    }



    (function initialize() {
        vatCommonService.isLayoutMenuShow(vatSessionService.project.id, vatSessionService.month
                                           , $scope.nodeDicKey, $scope.linkShort, $scope.menus);
    })();

}]);