﻿invoiceModule.controller('modelMappingAddEditController', ['$scope', '$log', '$q', '$translate', 'messagebox',
    'vatOutputInvoiceManageService', 'refreshFunc', 'model',
function ($scope, $log, $q,$translate, messagebox, vatOutputInvoiceManageService, refreshFunc, model) {
    var isEdit = !_.isEmpty(model);
    var pleaseSelect = $translate.instant("ChoosePlaceholder");
    var pleaseInput = $translate.instant('InputPlaceholder');
    var initSelectBoxes = function () {
        return $q.all([
            vatOutputInvoiceManageService.getModelSeries(),
            vatOutputInvoiceManageService.getCabinConfiguration()
        ]).then(function (result) {
            if (result && result[0] && result[0].data) {
                $scope.modelSeriesList = result[0].data;
            }
            else {
                $scope.modelSeriesList = [];
            }

            if (result && result[1] && result[1].data) {
                //$scope.cabinConfigurationList = _.map(result[1].data, function (x) {
                //    return _.isEmpty(x) ? 'NA' : x;
                //});
                //fix bug13211
                $scope.cabinConfigurationList = _.filter(result[1].data, function (x) {
                    return !_.isEmpty(x);
                });
               
            }
            else {
                $scope.cabinConfigurationList = [];
            }

            $scope.modelSeriesOption = {
                items: $scope.modelSeriesList,
                bindingOptions: {
                    value: 'model.modelSeries'
                },
                placeholder: pleaseSelect
            };

            $scope.cabinConfigurationOption = {
                items: $scope.cabinConfigurationList,
                bindingOptions: {
                    value: 'model.cabinConfiguration'
                },
                placeholder: pleaseSelect
            };
        });
    };

    //关闭弹窗口
    $scope.hidePopPanel = function () {
        $scope.$dismiss({ $value: 'cancel' });
    };

    $scope.saveModel = function () {
        if (_.isEmpty($scope.model.modelSeries)) {
            messagebox.warning('ModelSeriesRequired');
            return;
        }

        if (_.isEmpty($scope.model.cabinConfiguration)) {
            messagebox.warning('CabinConfigurationRequired');
            return;
        }

        if (_.isEmpty($scope.model.makeAndModel)) {
            messagebox.warning('MakeAndModelRequired');
            return;
        }

        var promise;
        if (isEdit) {
            promise = vatOutputInvoiceManageService.updateModelMappingConfig($scope.model);
        }
        else {
            promise = vatOutputInvoiceManageService.addModelMappingConfig($scope.model);
        }

        return promise.then(function (data) {
            if (!data || !data.data) {
                messagebox.warning('UnknownError');
            }
            else if (!data.data.result) {
                messagebox.warning(_.isEmpty(data.data.resultMsg) ? 'UnknownError' : data.data.resultMsg);
            }
            else {
                $scope.hidePopPanel();
                refreshFunc();
            }
        });
    };

    $scope.$watch('model.makeAndModel', function (newVal, oldVal) {
        var rtn = '';
        if (!_.isEmpty(newVal)) {
            var strs = newVal.split(' ');
            $scope.model.category = strs[0];
        }
        else {
            $scope.model.category = '';
        }
    });

    (function initialize() {
        $log.debug('modelMappingAddEditController.ctor()...');

        $scope.title = isEdit ? 'EditMapping' : 'AddNewMapping';
        var localModel = model ? angular.copy(model) : {};
        if (_.isEmpty(localModel.cabinConfiguration)) {
            localModel.cabinConfiguration = '';
        }

        $scope.model = localModel;
        initSelectBoxes();
        $log.debug($scope.model);
    })();
}]);