﻿vatModule.controller('ProductItemPreviewController', ['$scope', '$log', '$translate', '$timeout', 'SweetAlert', '$q', 'uiGridConstants', '$interval', 'productService', 'browserService', 'vatSessionService', 'region', 'enums', 'vatExportService',
    function ($scope, $log, $translate, $timeout, SweetAlert, $q, uiGridConstants, $interval, productService, browserService, vatSessionService, region, enums, vatExportService) {
        'use strict';

        $scope.startDate = new Date(vatSessionService.project.year, 0, 1);
        $scope.endDate = new Date(vatSessionService.project.year, 11, 31);
        $scope.dateFormat = $translate.instant('dateFormat4YearMonthDay');
        $scope.startMonth = vatSessionService.month;
        $scope.endMonth = vatSessionService.month;

        var minDate = [1, vatSessionService.project.year];
        var maxDate = [12, vatSessionService.project.year];
        var setDate = [
            [vatSessionService.month, vatSessionService.project.year],
            [vatSessionService.month, vatSessionService.project.year]];

        //发票类型
        var invoiceTypeEnum = {
            VATInvoice: $translate.instant('VATInvoice'),
            FreightTransport: $translate.instant('FreightTransport'),
            MotorVehicle: $translate.instant('MotorVehicle'),
            AgriculturalProduct: $translate.instant('AgriculturalProduct')
        };

        $scope.monthList = [$translate.instant('Month01'),
                            $translate.instant('Month02'),
                            $translate.instant('Month03'),
                            $translate.instant('Month04'),
                            $translate.instant('Month05'),
                            $translate.instant('Month06'),
                            $translate.instant('Month07'),
                            $translate.instant('Month08'),
                            $translate.instant('Month09'),
                            $translate.instant('Month10'),
                            $translate.instant('Month11'),
                            $translate.instant('Month12')
        ];


        //发票类型
        $scope.invoiceTypeList = [
            { id: 999, name: '未选择' },
            { id: 1, name: '1' },
            { id: 2, name: '2' },
            { id: 3, name: '0/空' },
        ];


        $scope.InvoiceType = {};
        $scope.CertificationStatus = {};

        //初始化期间
        var initPeriods = function () {
            var curMonth = new Date().getMonth() + 1;


            $scope.queryParams = {
                pageInfo: {}
                //periodStart: '',
                //periodEnd: '',
                //certificationDateStart: null,
                //certificationDateEnd: null,
                //invoiceCode: '',
                //invoiceNumber: '',
                //sellerTaxNumber: '',
                //amountStart: null,
                //amountEnd: null,
                //invoiceType: null,
                //taxAmountStart: null,
                //taxAmountEnd: null,
                //certificationStatus: null
            };
        };

        //从数据库中load数据
        var loadIncomeInvoiceItemDataFromDB = function (pageIndex) {
            initIncomeInvoiceItemPagination();

            $scope.curIncomeInvoiceItemPage = pageIndex;

            //初始化查询信息
            $scope.queryParams.pageInfo = {
                totalCount: $scope.queryIncomeInvoiceItemResult.pageInfo.totalCount,
                pageIndex: pageIndex,
                pageSize: $scope.queryIncomeInvoiceItemResult.pageInfo.pageSize,
                totalPage: 0,
            };

            productService.getProductItemListByPage($scope.queryParams).success(function (data) {
                if (data) {
                    var index = 1;
                    data.list.forEach(function (v) {
                        v.index = index++;
                    });
                    $scope.gridOptions.data = data.list;
                    $scope.queryIncomeInvoiceItemResult.pageInfo = data.pageInfo;
                    computeIncomeInvoiceItemPage();
                }
            });
        };

        //点击任意一页加载数据事件
        var loadIncomeInvoiceDataByPage = function (pageIndex) {
            loadIncomeInvoiceItemDataFromDB(pageIndex);
        };

        //计算页数，创建分页栏
        var computeIncomeInvoiceItemPage = function () {

            if ($scope.queryIncomeInvoiceItemResult.pageInfo && $scope.queryIncomeInvoiceItemResult.pageInfo.totalCount > 0) {

                var totalPage = parseInt($scope.queryIncomeInvoiceItemResult.pageInfo.totalCount / $scope.queryIncomeInvoiceItemResult.pageInfo.pageSize);
                totalPage = $scope.queryIncomeInvoiceItemResult.pageInfo.totalCount % $scope.queryIncomeInvoiceItemResult.pageInfo.pageSize == 0 ? totalPage : totalPage + 1;

                //计算本页记录数
                if ($scope.queryIncomeInvoiceItemResult.pageInfo.pageIndex === totalPage) {
                    $scope.curPageItemCount = $scope.queryIncomeInvoiceItemResult.pageInfo.totalCount % $scope.queryIncomeInvoiceItemResult.pageInfo.pageSize;
                }
                else {
                    $scope.curPageItemCount = $scope.queryIncomeInvoiceItemResult.pageInfo.pageSize;
                }

                $scope.queryIncomeInvoiceItemResult.pageInfo.totalPage = totalPage;

                var createPage = $("#totalInvoicePage").createPage({
                    pageCount: totalPage,
                    current: $scope.curIncomeInvoiceItemPage,
                    backFn: function (p) {
                        //单击回调方法，p是当前页码
                        loadIncomeInvoiceDataByPage(p);
                    }
                });

                $('#totalInvoicePage').css('display', 'inline-block');
            } else {
                var createPage = $("#totalInvoicePage").createPage({
                    pageCount: 0,
                    current: $scope.curIncomeInvoiceItemPage,
                    backFn: function (p) {
                        //单击回调方法，p是当前页码
                        loadIncomeInvoiceDataByPage(p);
                    }
                });

                //如果查询结果为0，则直接设置本页记录数为0
                $scope.curPageItemCount = 0;

                $('#totalInvoicePage').css('display', 'inline-block');
            }
        };

        //初始化分页信息
        var initIncomeInvoiceItemPagination = function () {
            $scope.queryIncomeInvoiceItemResult = {
                list: [],
                pageInfo: {
                    totalCount: -1,
                    pageIndex: 1,
                    pageSize: constant.pagesize,
                    totalPage: 0,
                }
            }

            $scope.curIncomeInvoiceItemPage = 1;
        };


        //在popover打开时执行事件
        var showPopover = function () {
            $timeout(function () {
                initDatePickers();
            }, 500);
        };

        //初始化时间控件
        var initDatePickers = function () {

            ////初始化已选择的发票类型和认证结果
            //$scope.InvoiceType.selected = _.find($scope.invoiceTypeList, function (v) {
            //    return v.id == $scope.queryParams.invoiceType;
            //})

        };

        (function initialize() {
            $log.debug('VatPreviewInputInvoiceController.ctor()...');
            $('#input-invoice-period-picker').focus(function () {
                $('.filter-button').popover("hide");
            });
            //初始化month-picker
            $('#input-invoice-period-picker').rangePicker({
                minDate: minDate,
                maxDate: maxDate,
                setDate: setDate,
                months: $scope.monthList,//['1月', '2月', '3月', '4月', '5月', '6月', '7月', '8月', '9月', '10月', '11月', '12月'],
                ConfirmBtnText: $translate.instant('Confirm'),
                CancelBtnText: $translate.instant('ButtonCancel')
            })
             .on('datePicker.done', function (e, result) {
                 //开始月份
                 var startMonth = result[0][0];
                 //结束月份
                 var endMonth = result[1][0];
                 $scope.startMonth = startMonth;
                 $scope.endMonth = endMonth;

                 //$scope.queryParams.periodStart = startMonth;
                 //$scope.queryParams.periodEnd = endMonth;

                 loadIncomeInvoiceItemDataFromDB(1);
             });


            $scope.gridOptions = {
                rowHeight: constant.UIGrid.rowHeight,
                selectionRowHeaderWidth: constant.UIGrid.rowHeight,
                virtualizationThreshold: 50,//默认加载50条数据，避免在数据展示时，只显示前面4条
                enableSorting: false,
                enableColumnMenus: false,
                columnDefs: [
                 { name: '序号', width: '6%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.index}}<span></div>' },
                 { name: '产品编号', width: '8%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.fSetCode}}<span></div>' },
                 { name: '产品名称', width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.fSetName}}<span></div>' },
                 { name: '科目代码', width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.fAcctCode}}<span></div>' },
                 { name: '科目名称', width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.fAcctName}}</span></div>' },
                 { name: '科目类别', width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.fAcctClass}}</span></div>' },
                 { name: '科目性质', width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.fAcctAttr}}</span></div>' },
                 { name: '卖出金额汇总', width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.fcjje}}</span></div>' },
                 { name: '计税基数余额', width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.bjsjzye}}</span></div>' },
                 { name: '应税状态', width: '8%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.fyszt}}</span></div>' },
                 { name: '期间', width: '8%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.year + "-" + (row.entity.month < 10 ? "0" + row.entity.month : row.entity.month)}}</span></div>' }
                ],
                onRegisterApi: function (gridApi) {
                    $scope.gridApi = gridApi;

                    $interval(function () {
                        $scope.gridApi.core.handleWindowResize();
                    }, 500, 60 * 60 * 8);
                }
            };

            $scope.showPopover = showPopover;

            initPeriods();
            initIncomeInvoiceItemPagination();
            //初始化查询条件-期间范围
            //$scope.queryParams.periodStart = vatSessionService.month;
            //$scope.queryParams.periodEnd = vatSessionService.month;
            loadIncomeInvoiceItemDataFromDB(1);

        })();
    }
]);




